<template>
  <div
    data-component-group="filter-forms"
    data-component="contract"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <v-autocomplete
        v-model="business"
        :items="businesses"
        :filter="customFilter"
        :loading="isLoadingBusinesses"
        prepend-inner-icon="home"
        :return-object="true"
        item-text="name"
        label="Business"
        :menu-props="{nudgeBottom:'10'}"
        :search-input.sync="businessSearch"
      />

      <v-autocomplete
        v-model="country"
        :items="countries"
        :filter="customFilter"
        prepend-inner-icon="public"
        :return-object="true"
        item-text="name"
        label="Country"
        :menu-props="{nudgeBottom:'10'}"
      />

      <v-autocomplete
        v-model="status"
        :items="statuses"
        :filter="customFilter"
        prepend-inner-icon="change_history"
        :return-object="true"
        item-text="name"
        label="Status"
        :menu-props="{nudgeBottom:'10'}"
      />

      <v-autocomplete
        v-model="owner"
        :items="owners"
        :filter="customFilter"
        :loading="isLoadingManagers"
        prepend-inner-icon="account_circle"
        :return-object="true"
        item-text="name"
        label="Contract owner"
        :menu-props="{nudgeBottom:'10'}"
        :search-input.sync="ownerSearch"
      />

      <base-date-picker
        :date="date"
        placeholder="Expire before"
        :on-change="onChangeDate"
      />
    </FiltersForm>
  </div>
</template>

<script>
  import uid from 'uid';
  import colors from 'vuetify/es5/util/colors';
  import FiltersForm from './Filters';
  import { isNum, isStr, debounce } from '../../../utils';

  const debouncer = debounce({
    id: uid(),
    timeout: 500
  });

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    data() {
      return {
        business: {},
        businesses: [],
        businessSearch: '',
        country: {},
        status: {},
        owner: {},
        owners: [],
        ownerSearch: '',
        date: '',
        colors,
        isLoadingBusinesses: false,
        isLoadingManagers: false
      };
    },
    computed: {
      hasFilters() {
        const { business, country, status, owner, date } = this;

        return isNum(business.id)
          || isStr(country.code)
          || isNum(status.id)
          || isNum(owner.id)
          || date !== '';
      },
      countries() {
        return this.$store.getters['users/countries'];
      },
      activeCountry() {
        return this.$store.getters['config/country'];
      },
      statuses() {
        return this.$store.getters['contracts/statuses'];
      }
    },
    watch: {
      businessSearch(nextSearch) {
        if (isStr(nextSearch)) {
          debouncer(() => this.getBusinesses(nextSearch));
        }
      },
      ownerSearch(nextSearch) {
        if (isStr(nextSearch)) {
          debouncer(() => this.getManagers(nextSearch));
        }
      }
    },
    created() {
      this.getStatuses();
    },
    methods: {
      getStatuses() {
        return this.$store.dispatch('contracts/getStatuses');
      },
      onFilter() {
        const { business, country, status, owner, date } = this;

        this.$emit('filter', {
          business: business.id,
          country: country.code,
          status: status.id,
          owner: owner.id,
          date
        });
      },
      onClearFilters() {
        this.business = {};
        this.country = {};
        this.status = {};
        this.owner = '';
        this.date = '';

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      onChangeDate(date) {
        this.date = date;
      },
      getBusinesses(search = '') {
        const query = {
          per_page: -1,
          search,
          target_country: this.activeCountry.code
        };

        this.isLoadingBusinesses = true;
        return this.$store.dispatch('businesses/getItems', query)
          .then(({ items }) => {
            this.businesses = items;
            this.isLoadingBusinesses = false;
            return items;
          })
          .catch((err) => {
            this.isLoadingBusinesses = false;
            return err;
          });
      },
      getManagers(search = '') {
        const query = {
          per_page: -1,
          search
        };

        this.isLoadingManagers = true;
        return this.$store.dispatch('users/getManagers', query)
          .then((items) => {
            this.owners = items;
            this.isLoadingManagers = false;
            console.log(this.owners);
            return items;
          })
          .catch((err) => {
            this.isLoadingManagers = false;
            return err;
          });
      }
    }
  };
</script>

<style lang="stylus" scoped>
  [data-component-group="filter-forms"] {
    &[data-component="contract"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }
    }
  }
</style>
